/**
 * Provides a visual example of the class and block
 * synchronization syntax.
 *
 * @author Christian Ratliff
 */
public class Sync {
  /** I exist to make syntax errors! */
  private static int syntaxError;

  /** I exist as a foil to the syntax error! */
  private static Integer syntaxOkay;

  /**
   * Allocates and returns a handle to the shared number.
   *
   * @return A reference to a globally shared number
   *        object.
   */
  public static synchronized Integer getInteger() {
    if (Sync.syntaxOkay == null) {
      Sync.syntaxOkay = new Integer(99);
    }

    return Sync.syntaxOkay;
  }

  /**
   * Returns the current value of the shared integer as
   * a simple int.
   *
   * @return The current value of the shared integer.
   */
  public static int getint() {
    synchronized (Sync.syntaxOkay) {
      Sync.syntaxOkay = new Integer(Sync.syntaxOkay.intValue() + 1);
    }
    return Sync.syntaxOkay.intValue();
  }

  public static void main(String[] argv) {
    Integer bign = Sync.getInteger();
    int littlen = Sync.getint();

    System.out.println("Got: big="+bign.intValue()+" little="+littlen);
  }
}
