
import java.lang.Thread;

public class CounterThread3 extends Thread {

  protected long count = -1;
  protected long countMax;
  protected boolean ready = false;

  public CounterThread3(long countTo) {
    super();
    this.countMax = countTo;
  }

  public synchronized long getCount() {
    try { if (this.isAlive()) { this.wait(); } } catch (InterruptedException ie) { }
    return this.count;
  }

  public synchronized void setCount(long cnt) {
    this.count = cnt;
    this.notifyAll();
  }

  public void run() {
    System.out.println("THREAD: starting");
    long cnt = 0;

    while (cnt++ < this.countMax) {
      this.setCount(cnt);
    }
    System.out.println("THREAD: ending");
  }

  public static void main(String[] argv) {
    long cnt = 0;
    long max = Long.parseLong(argv[0]);
    CounterThread3 cntThread = new CounterThread3(max);
    
    cntThread.start();

    while (cntThread.isAlive()) {
      System.out.println("MAIN: "+cntThread.getCount());
      cnt++;
    }
    System.out.println("MAIN: ending at "+cntThread.getCount()+", picked "+cnt+" values.");
  }
}

/* change run to synchronized to demonstrate race conditions */
