
/**
 * Implemented by thread creators which wish
 * to be notified when threads they create emit
 * an exception. To add support for this feature,
 * be sure to create an instance of the 
 * ThreadGroupWatcher and establish your subthreads
 * through its methods.
 *
 * @author Christian Ratliff
 */
interface ThreadExceptionListener {

  /**
   * Relays the exception information emitted by
   * a subthread.
   * 
   * @param event A complete description of the
   *       exception.
   */
  public void exceptionEmitted(ThreadExceptionEvent event);
}

